var JPushSetTags = function(scriptParam) {
    LocStorage.set('JPushBackScript', JSON.stringify(scriptParam));
    var login = JSON.parse(LocStorage.get('UserAgent'));
    var tags = [],
        sysname = login.isSalesMan == '1' ? '供应商服务平台' : 'B2B移动端';
    //系统标签
    tags.push(sysname);
    //公司标签
    tags.push(login.branchId);
    //登录账号
    tags.push($('[name="name"]').val());

    log('获取到的JPushType：' + LocStorage.get('JPushType'));
    var JPushType = JSON.parse(LocStorage.get('JPushType'));
    for (var type in JPushType) {
        if (JPushType[type]) {
            tags.push(type);
        }
    }

    var jsonStr = JSON.stringify({
        tags : tags
    });
    log('设置标签:' + jsonStr);
    if ( typeof uexJPush != "undefined") {
        //设置标签
        uexJPush.cbSetTags = function(data) {
            log('设置标签的回调:' + data);

            var json = JSON.parse(data);
            if (parseInt(json.result) != 0) {
                log('设置标签失敗！');

                if (!LocStorage.get('JPushTags')) {
                    JPushSetTags();
                }
            }
            LocStorage.set('JPushTags', JSON.stringify(json.tags));

            afterResetTag();
            log('回调执行前的jtype:' + LocStorage.get('JPushType'));
            var scriptParam = JSON.parse(LocStorage.get('JPushBackScript'));
            LocStorage.remove('JPushBackScript');
            callback(json, scriptParam);

        };
        uexJPush.setTags(jsonStr);
    }
}
var afterResetTag = function() {
    var tags = LocStorage.get('JPushTags');
    log('现有tag:' + tags);
    if (tags) {
        tags = JSON.parse(tags);
        var JPushType = JSON.parse(LocStorage.get('JPushType'));
        for (var tag in JPushType) {
            var val = false;
            if (tags.indexOf(tag) != -1) {
                val = true;
            }
            JPushType[tag] = val;
        }

        LocStorage.set('JPushType', JSON.stringify(JPushType));
    } else {
        tags = [];
    }
}
var RegistrationID,
    opId = (new Date()).getUTCMilliseconds(),
    path = "wgt://data/JPush.txt",
    isFileExist = false,
    jpushFileInterval,
    jpushFileEditInterval;

var waitFileCheck = function(backFn, param) {
    log('等待文件创建！');
    jpushFileInterval = setInterval(function() {
        if (isFileExist) {
            clearInterval(jpushFileInterval);
            backFn(param);
        }
    }, 100);
}
var waitFileEditCheck = function(backFn, param) {
    jpushFileEditInterval = setInterval(function() {
        if (JPushFile.isEditing) {
            clearInterval(jpushFileEditInterval);
            backFn(param);
        }
    }, 100);
}
var JPushFile = {
    isEditing : false,
    init : function() {
        uexFileMgr.cbCreateFile = function(opCode, dataType, data) {
            //log('创建文件的回调:' + data + '     ' + (data == 0 ? '创建文件成功' : '创建文件失败'));
            if (data == 0) {
                isFileExist = true;
            }
        }

        uexFileMgr.cbIsFileExistByPath = function(opCode, dataType, data) {
            //log('判断文件是否存在回调:' + data + '     ' + (data == 0 ? '文件不存在' : '文件存在'));
            if (data == 0) {
                uexFileMgr.createFile(opId, path);
                uexFileMgr.closeFile(pathId);
            } else if (data == 1) {
                isFileExist = true;
            }
        }
        uexFileMgr.isFileExistByPath(opId, path);
    },
    write : function(content, callbackFn) {
        if (isFileExist) {
            if (JPushFile.isEditing) {
                setTimeout(function() {
                    log('再次请求write:' + JSON.stringify(content));
                    JPushFile.write(content, callbackFn);
                }, 50);
                return;
            }
            JPushFile.isEditing = true;
            uexFileMgr.cbReadFile = function(opCode, dataType, data) {
                log('写入时读取文件的回调:' + data);
                data = JSON.parse(data || "{\"Other\":[]}");
                if ($.isArray(data)) {
                    data = JSON.parse("{\"Other\":[]}");
                }
                var extras = content.extras || {};

                if (extras.jzttype == 'OrderLogistics' || extras.jzttype == 'Lecense') {
                    content.isRead = true;
                }
                if (content.extras && extras.type && extras.jzttype && extras.id) {
                    log('type:' + extras.type + '     jzttype:' + extras.jzttype + '     id:' + extras.id);
                    if (!data[extras.type]) {
                        data[extras.type] = {};
                    }
                    if (!data[extras.type][extras.jzttype]) {
                        data[extras.type][extras.jzttype] = {};
                    }
                    data[extras.type][extras.jzttype][extras.id] = content;
                } else {
                    data.Other.push(content);
                }
                var jsonStr = JSON.stringify(data);
                uexFileMgr.openFile(opId, path, '1');
                log('请求写入文件内容已编码:' + jsonStr);
                uexFileMgr.writeFile(opId, 0, jsonStr);
                uexFileMgr.closeFile(opId);
                JPushFile.isEditing = false;

                if ( typeof callbackFn == 'function') {
                    callbackFn();
                }
            }

            uexFileMgr.openFile(opId, path, '1');
            uexFileMgr.readFile(opId, '-1');
            uexFileMgr.closeFile(opId);

        } else {
            //log('本地JPush文件不存在且创建失败');
            waitFileCheck(JPushFile.write, content);
        }
    },
    read : function(content) {
        if (isFileExist) {
            if (JPushFile.isEditing) {
                setTimeout(function() {
                    log('文件编辑导致再次请求read:' + JSON.stringify(content));
                    JPushFile.read(content, callbackFn);
                }, 50);
                return;
            }
            JPushFile.isEditing = true;
            uexFileMgr.cbReadFile = function(opCode, dataType, data) {
                log('读取回写文件的回调:' + data);
                data = JSON.parse(data || "{\"Other\":[]}");
                if ($.isArray(data)) {
                    data = JSON.parse("{\"Other\":[]}");
                }

                var isCanReWrite = true;
                var extras = content.extras || {};
                if (content.extras && extras.type && extras.jzttype && extras.id) {
                    if (data[extras.type] && data[extras.type][extras.jzttype] && data[extras.type][extras.jzttype][extras.id]) {
                        data[extras.type][extras.jzttype][extras.id]['isRead'] = true;
                    } else {
                        isCanReWrite = false;
                    }
                } else {
                    JPushFile.isEditing = false;
                    return;
                }

                if (!isCanReWrite) {
                    JPushFile.isEditing = false;
                    setTimeout(function() {
                        log('数据未被写入导致再次请求read:' + JSON.stringify(content));
                        JPushFile.read(content);
                    }, 500);
                    return;
                }

                var jsonStr = JSON.stringify(data);
                uexFileMgr.openFile(opId, path, '1');
                log('JPush读取回写:' + jsonStr);
                uexFileMgr.writeFile(opId, 0, jsonStr);
                uexFileMgr.closeFile(opId);
                JPushFile.isEditing = false;

            }

            uexFileMgr.openFile(opId, path, '1');
            uexFileMgr.readFile(opId, '-1');
            uexFileMgr.closeFile(opId);

        } else {
            //log('本地JPush文件不存在且创建失败!');
            waitFileCheck(JPushFile.read, content);
        }
    },
    getAll : function(scriptParam) {
        if (isFileExist) {
            if (JPushFile.isEditing && scriptParam) {
                setTimeout(function() {
                    log('文件编辑导致再次请求getAll');
                    JPushFile.getAll(scriptParam);
                }, 50);
                return;
            }
            JPushFile.isEditing = true;
            uexFileMgr.cbReadFile = function(opCode, dataType, data) {
                log('获取读消息读取文件的回调:' + data);
                data = JSON.parse(data || "{}");
                if ($.isArray(data)) {
                    data = JSON.parse("{}");
                }

                var result = {};
                for (var typeName in data) {
                    var typeData = data[typeName];
                    if (typeName == 'Other') {
                        result[typeName] = typeData;
                    } else {
                        for (var jzttypeName in typeData) {
                            result[jzttypeName] = [];
                            var jzttypeData = typeData[jzttypeName];
                            for (var id in jzttypeData) {
                                var item = jzttypeData[id];
                                log('读取消息:' + JSON.stringify(item));
                                // result[jzttypeName].push(item);
                                var itemDate = item['extras']['sendtime'].substr(0, 10);
                                var tmp = itemDate.split("-");
                                var date1 = new Date(tmp[0], tmp[1] - 1, tmp[2]);
                                var myDate = new Date();
                                var mydate = myDate.getFullYear() + '-' + (myDate.getMonth() + 1) + '-' + myDate.getDate();
                                tmp = mydate.split("-");
                                var date2 = new Date(tmp[0], tmp[1] - 1, tmp[2]);
                                if (date2.getTime() - date1.getTime() < 31 * 24 * 60 * 60 * 1000) {
                                    //读取小于31天的记录
                                    result[jzttypeName].push(item);
                                } else {
                                    log("消息推送时间大于或等于31天，不读取！");
                                }
                            }
                        }
                    }
                }
                log('消息:' + JSON.stringify(result));
                callback(result, scriptParam);
                JPushFile.isEditing = false;
            }

            uexFileMgr.openFile(opId, path, '1');
            uexFileMgr.readFile(opId, '-1');
            uexFileMgr.closeFile(opId);

        } else {
            //alert('本地JPush文件不存在且创建失败!');
            waitFileCheck(JPushFile.getAll, scriptParam);
        }
    },
    getNoRead : function(scriptParam) {
        if (isFileExist) {
            if (JPushFile.isEditing) {
                setTimeout(function() {
                    log('文件编辑导致再次请求getNoRead');
                    JPushFile.getNoRead(scriptParam);
                }, 50);
                return;
            }
            JPushFile.isEditing = true;
            uexFileMgr.cbReadFile = function(opCode, dataType, data) {
                log('获取未读消息读取文件的回调:' + data);
                data = JSON.parse(data || "{\"Other\":[]}");
                if ($.isArray(data)) {
                    data = JSON.parse("{\"Other\":[]}");
                }

                var result = {};
                for (var typeName in data) {
                    var typeData = data[typeName];
                    if (typeName == 'Other') {
                        result[typeName] = typeData;
                    } else {
                        for (var jzttypeName in typeData) {
                            result[jzttypeName] = [];
                            var jzttypeData = typeData[jzttypeName];
                            for (var id in jzttypeData) {
                                var item = jzttypeData[id];

                                log('获取未读消息:' + JSON.stringify(item));
                                if (!item['isRead']) {
                                    result[jzttypeName].push(item);
                                }
                            }
                        }
                    }
                }
                log('未读消息:' + JSON.stringify(result));
                callback(result, scriptParam);
                JPushFile.isEditing = false;
            }

            uexFileMgr.openFile(opId, path, '1');
            uexFileMgr.readFile(opId, '-1');
            uexFileMgr.closeFile(opId);

        } else {
            //alert('本地JPush文件不存在且创建失败!');
            waitFileCheck(JPushFile.getNoRead, scriptParam);
        }
    },
    getNoReadCount : function(scriptParam) {
        if (isFileExist) {
            if (JPushFile.isEditing) {
                setTimeout(function() {
                    log('文件编辑导致再次请求getNoRead');
                    JPushFile.getNoRead(scriptParam);
                }, 50);
                return;
            }
            JPushFile.getNoRead(function(data) {
                var result = {};
                for (var type in data) {
                    result[type] = data[type].length;
                }
                callback(result, scriptParam);
            });
        } else {
            //alert('本地JPush文件不存在且创建失败!');
            waitFileCheck(JPushFile.getNoReadCount, scriptParam);
        }
    },
    clean : function(content) {
        if (isFileExist) {
            var data = '';
            uexFileMgr.openFile(opId, path, '1');
            uexFileMgr.writeFile(opId, '0', data);
            log('文件已清空！');
            uexFileMgr.closeFile(opId);

        } else {
            //alert('本地JPush文件不存在且创建失败!');
            waitFileCheck(JPushFile.clean, content);
        }
    }
}


appcan.ready(function() {
    LocStorage.set('JPushType', JSON.stringify({
        /*缺货篮到货*/
        OutOfStockBasket : true,

        /*订单物流状态*/
        OrderLogistics : true,

        /*问题反馈*/
        Sys_Feedback : true,
        /*投诉建议*/
        Sys_Complain : true,

        /*关注*/
        Collect : true,
        /*购物车*/
        ShoppingCart : true,
        /*历史采购*/
        PreviouslyPurchased : true,
        /*限时抢购*/
        Sales_BuyLimit : true,
        /*会员专享*/
        Sales_OnlyMembership : true,
        /*有买有送*/
        Sales_BuySend : true,
        /*促销返现*/
        Sales_Cashback : true,
        /*精品组合*/
        Sales_Combined : true,
        /*线上专区*/
        Sales_Online : true,
        /*展销会*/
        Sales_Display : true,
        /* 厂家专题 */
        Manufacturer_Topic : true,
        /* 缺货篮促销 */
        StockBasketPromotion : true,
        /* 资质即将到期 */
        Lecense : true,
    }));

    afterResetTag();

    JPushFile.init();

    uexWidget.onSuspend = function() {
        log("程序挂起");
    }

    uexWidget.onResume = function() {
        log("程序恢复");
    }
    if ( typeof uexJPush != "undefined") {

        //应用程序注册监听
        uexJPush.onReceiveRegistration = function(data) {
            log('JPush应用程序注册监听' + data);
            var json = JSON.parse(data);
            RegistrationID = json.title;
        };

        //收到了自定义消息
        uexJPush.onReceiveMessage = onReceiveMessage;

        //收到了通知
        uexJPush.onReceiveNotification = receiveNotification;
        //用户点击了通知
        uexJPush.onReceiveNotificationOpen = receiveNotification;
    }
});

var receiveNotification = function(data) {
    log('收到或点击通知:' + data);
    var json = JSON.parse(data),
        msg = json.content,
        title = '通知';

    JPushFile.write(json);
    //JPushFile.read(json);

    if ( typeof (json.content) == 'object') {
        title = json.content.title || '通知';
        msg = json.content.body;
    }

    alert(msg, {
        title : title,
        callback : function() {
            log('收到或点击通知,请求read.' + JSON.stringify(json));
            JPushFile.read(json);
            if (isPhone) {
                uexJPush.setBadgeNumber(0);
            }
        }
    });
}
var onReceiveMessage = function(data) {
    log('收到了自定义消息' + data);
    var json = JSON.parse(data);
    JPushFile.write(json);
};

var callback = function(result, scriptParam) {
    if (scriptParam) {
        //var scriptContent = '(' + scriptParam.scriptContent + ')(' + JSON.stringify(result) + ')';
        var scriptContent = scriptParam.scriptContent + '(' + JSON.stringify(result) + ')';
        scriptParam.scriptContent = scriptContent;
        if ( typeof scriptParam == 'function') {
            scriptParam(result);
        } else if (scriptParam.inPageName) {
            uexWindow.evaluateMultiPopoverScript(scriptParam.name, scriptParam.popName, scriptParam.inPageName, scriptParam.scriptContent);
        } else if (scriptParam.popName) {
            appcan.frame.evaluateScript(scriptParam);
        } else if ( typeof scriptParam.name != 'undefined') {
            appcan.window.evaluateScript(scriptParam);
        }
    }
}
