/*
* 参数说明：
* div:(string)包含生成的多级select控件的DIV
* treelist:(array)填充多级select的数据
*  "treeList": [                   --组织结构列表
{
"id": 37,                 --组织结构ID
"children": null,         --子组织结构 array
"text": "无锡市"}           --这个组织结构的名称
]
*
*
*
*/

//记录最深的select是第几层级
var highestLevel = 0;
//包含生成的多层级select控件的DIV对象$()
var OuterDiv;
var initMultiSelect = function(div, treeList) {
    OuterDiv = div;
    if (treeList && treeList.length > 0) {
        OuterDiv.empty();
        var selectDiv = '<select id="select' + highestLevel + '" class="prov my-uinn uc-a1 myselectcss bc-border" level=' + highestLevel + ' ></select>';
        OuterDiv.append(selectDiv);
        var selectCon = $('#select' + highestLevel);
        Init.select(selectCon, treeList, 'id', 'text');
        selectCon.bind('change', optionChange);
    }
}

//select值改变时执行，初始化或重置下层，隐藏其他层
var optionChange = function() {
    checkField1();
    var currentSelect = $(this);
    var index = currentSelect.get(0).selectedIndex;
    //var data = currentSelect.find("option:selected").attr('data');
    var data =$(currentSelect.find("option")[index]).attr('data');
    var currentLevel = parseInt(currentSelect.attr('level'));

    if (!data) {
        currentSelect.nextAll('select').addClass('uhide');
        return;
    }
    data = JSON.parse(data);
    var children = data.children;
    if (!children || !children.length) {
        currentSelect.nextAll('select').addClass('uhide');
        return;
    }
    var nextSelect = $('#select' + (currentLevel + 1));
    if (currentLevel < highestLevel || nextSelect.length > 0) {
        resetSelect(nextSelect, children, 'id', 'text');
        nextSelect.removeClass('uhide');
        nextSelect.nextAll('select').addClass('uhide');
        return;
    }

    highestLevel++;
    var selectDiv = '<select id="select' + highestLevel + '" class="prov my-uinn uc-a1 myselectcss bc-border" level=' + highestLevel + ' ></select>';
    OuterDiv.append(selectDiv);
    var selectCon = $('#select' + highestLevel);
    Init.select(selectCon, children, 'id', 'text');
    selectCon.bind('change', optionChange);
    currentSelect.next('select').removeClass('uhide');

}
//切换上层select时，重置下层select的值
var resetSelect = function(select, data, val, text) {
    if (!select[0]) {
        //log('重置,控件不是jquery对象');
    }
    select.empty();
    var select_option = $('<option value="">请选择</option>');
    select.append(select_option);
    $.each(data, function(index, item) {
        select_option = $('<option value="' + item[val] + '" data_index="' + (index + 1) + '" >' + item[text] + '</option>');
        select_option.attr('data', JSON.stringify(item));
        select.append(select_option);
    });
    select[0].selectedIndex = 0;
}


//切换select值时，清空人员姓名，调整搜索条件区的高度
var checkField1 = function() {
    $("#salesManChoose").val(null);
    var h1 = $('#space').height();
    var h2 = $('#selectConditions').height();
    $('#space').height(h2);
    var h3 = $('#space').height();
}
//获取select最深层选中的id
var getSelectedID = function() {
    if(typeof OuterDiv=='undefined'){
        return '';
    }
    var allselect = OuterDiv.find('select');
    var selectedId = '';
    $.each(allselect, function(index, item) {
        item = $(item);
        if (!item.hasClass('uhide') && item.val()) {
            selectedId = item.val();
        }
    });
    return selectedId;
}

