/*
 * 易宝在线支付
 * @param {Object} payData  支付参数
 * {
 * productName : 产品名称,可不传，默认值：九州通医药网
 * fcallbackurl : 返回路径，可不传，默认值：http://mob.jzterp.com:8085/i9LightApp/test/10.html
 * price : 支付金额,订单支付时不传
 * linkOrder : 订单编号，回款时不传
 * directpaytype : （可不传）支付方式，0为默认付款方式（一键支付、支付宝、微信三选一）,1为微信支付,2为支付宝支付,3为一键支付（银行卡付款）——目前只有一键支付
 * lastWinName : 订单或者回款确认页面窗口名称
 * updateFtn:在上一个页面需要执行方法刷新页面的方法名称,
 * updateData:刷新方参数
 * }
 */
var yeePayOnline = {
    pay : function(payData) {
        /*if (!payData.linkOrder || payData.linkOrder == 'undefined') {
         //linkOrder，则不传
         }*/
        if(!payData.productName){
            payData.productName ="九州通医药网";
        }
        if (!payData.directpaytype || payData.directpaytype == 'undefined') {
            //如果未传directpaytype，则默认为一键支付——3
            payData.directpaytype = 3;
        }
        if (!payData.fcallbackurl || payData.fcallbackurl == 'undefined') {
            //fcallbackurl，则默认打开http://mob.jzterp.com:8085/i9LightApp/test/10.html
            payData.fcallbackurl = 'http://mob.jzterp.com:8085/i9LightApp/test/10.html';
        }
        AjaxFn(urls.B2B_ONLINEPAY_PAY, payData, function(result) {
            if (result.success) {
                if (payData.directpaytype && payData.directpaytype == 2) {
                     //支付宝——通过调用浏览器调用支付宝APP进行支付
                    var payurl = result.data.payurl;
                    //value， Number类型,0为iOS,1为Android
                    var value = uexWidgetOne.platformName;
                    if (value == "android") {
                        uexWidget.startApp("1", "android.intent.action.VIEW", '{"data":{"mimeType":"text/html","scheme":"' + payurl + '"}}');
                    } else {
                        uexWidget.loadApp(payurl, null, null);
                    }
                    if (payData.lastWinName) {
                        setTimeout(function() {
                            appcan.window.evaluateScript({
                                name : payData.lastWinName,
                                scriptContent : 'appcan.window.close(-1);'
                            });
                        }, 3000);
                    }
                   

                } else {
                    LocStorage.set('payurl', result.data.payurl);
                    if (payData.lastWinName&&payData.updateFtn) {
                        open({
                            name : 'payOnline',
                            data : 'payOnline.html?lastWinName=' + payData.lastWinName+'&updateFtn='+payData.updateFtn
                        });
                    } else if(payData.lastWinName&&!payData.updateFtn){
                        open({
                            name : 'payOnline',
                            data : 'payOnline.html?lastWinName=' + payData.lastWinName
                        });
                    }else if(!payData.lastWinName&&!payData.updateFtn){
                        open({
                            name : 'payOnline',
                            data : 'payOnline.html'
                        });
                    }

                }
            }
        }, {
            successException : function(result) {
              if(!result.success){
                  alert("获取支付信息失败，请联系管理员！");
              }
            }
        });
    }
}
